#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Jun 29 19:44:06 2022

@author: tanu
"""
import sys, os
import pandas as pd
import numpy as np
import re
from copy import deepcopy
from sklearn import linear_model
from sklearn import datasets
from collections import Counter

from sklearn.linear_model import LogisticRegression, LogisticRegressionCV
from sklearn.linear_model import RidgeClassifier, RidgeClassifierCV, SGDClassifier, PassiveAggressiveClassifier

from sklearn.naive_bayes import BernoulliNB
from sklearn.neighbors import KNeighborsClassifier
from sklearn.svm import SVC
from sklearn.tree import DecisionTreeClassifier, ExtraTreeClassifier
from sklearn.ensemble import RandomForestClassifier, ExtraTreesClassifier, AdaBoostClassifier, GradientBoostingClassifier, BaggingClassifier
from sklearn.naive_bayes import GaussianNB
from sklearn.gaussian_process import GaussianProcessClassifier, kernels
from sklearn.gaussian_process.kernels import RBF, DotProduct, Matern, RationalQuadratic, WhiteKernel

from sklearn.discriminant_analysis import LinearDiscriminantAnalysis, QuadraticDiscriminantAnalysis
from sklearn.neural_network import MLPClassifier

from sklearn.svm import SVC
from xgboost import XGBClassifier
from sklearn.naive_bayes import MultinomialNB
from sklearn.preprocessing import StandardScaler, MinMaxScaler, OneHotEncoder

from sklearn.compose import ColumnTransformer
from sklearn.compose import make_column_transformer

from sklearn.metrics import make_scorer, confusion_matrix, accuracy_score, balanced_accuracy_score, precision_score, average_precision_score, recall_score
from sklearn.metrics import roc_auc_score, roc_curve, f1_score, matthews_corrcoef, jaccard_score, classification_report

# added
from sklearn.model_selection import train_test_split, cross_validate, cross_val_score, LeaveOneOut, KFold, RepeatedKFold, cross_val_predict

from sklearn.model_selection import train_test_split, cross_validate, cross_val_score
from sklearn.model_selection import StratifiedKFold,RepeatedStratifiedKFold, RepeatedKFold

from sklearn.pipeline import Pipeline, make_pipeline

from sklearn.feature_selection import RFE, RFECV

import itertools
import seaborn as sns
import matplotlib.pyplot as plt

from statistics import mean, stdev, median, mode

from imblearn.over_sampling import RandomOverSampler
from imblearn.under_sampling import RandomUnderSampler
from imblearn.over_sampling import SMOTE
from sklearn.datasets import make_classification
from imblearn.combine import SMOTEENN
from imblearn.combine import SMOTETomek

from imblearn.over_sampling import SMOTENC
from imblearn.under_sampling import EditedNearestNeighbours
from imblearn.under_sampling import RepeatedEditedNearestNeighbours

from sklearn.model_selection import GridSearchCV
from sklearn.base import BaseEstimator
from sklearn.impute import KNNImputer as KNN
import json
import argparse
import re
import itertools
from sklearn.model_selection import LeaveOneGroupOut
###############################################################################
homedir = os.path.expanduser("~")
sys.path.append(homedir + '/git/LSHTM_analysis/scripts/ml/ml_functions')
sys.path
###############################################################################
#====================
# Import ML functions 
#====================
from ml_data_combined import *
from MultClfs_logo_skf import *
#from GetMLData import *
#from SplitTTS import *

skf_cv = StratifiedKFold(n_splits = 10 , shuffle = True, random_state = 42)

#logo = LeaveOneGroupOut()

#%%
def CMLogoSkf(combined_df
        , all_genes =  ["embb", "katg", "rpob", "pnca", "gid", "alr"]
        , bts_genes = ["embb", "katg", "rpob", "pnca", "gid"]
        , cols_to_drop = ['dst', 'dst_mode', 'gene_name']
        , target_var = 'dst_mode'
        , gene_group = 'gene_name'
        , std_gene_omit = []
        ):

    for bts_gene in bts_genes:
        print('\n BTS gene:', bts_gene)
        if not std_gene_omit:
            training_genesL = ['alr']
        else:
            training_genesL = []
            
        tr_gene_omit = std_gene_omit + [bts_gene]
        n_tr_genes = (len(bts_genes) - (len(std_gene_omit)))
        #n_total_genes = (len(bts_genes) - len(std_gene_omit))
        n_total_genes = len(all_genes)
        
        training_genesL = training_genesL + list(set(bts_genes) - set(tr_gene_omit))
        #training_genesL = [element for element in bts_genes if element not in tr_gene_omit]
    
        print('\nTotal genes: ', n_total_genes
              ,'\nTraining on:', n_tr_genes
              ,'\nTraining on genes:', training_genesL
              , '\nOmitted genes:', tr_gene_omit
              , '\nBlind test gene:', bts_gene) 
            
        tts_split_type = "logo_skf_BT_" + bts_gene
        
        outFile = "/home/tanu/git/Data/ml_combined/" + str(n_tr_genes+1) + "genes_" + tts_split_type + ".csv"
        print(outFile)
    
        #-------
        # training
        #------
        cm_training_df = combined_df[~combined_df['gene_name'].isin(tr_gene_omit)]
        
        cm_X = cm_training_df.drop(cols_to_drop, axis=1, inplace=False)
        #cm_y = cm_training_df.loc[:,'dst_mode']
        cm_y = cm_training_df.loc[:, target_var]
    
        gene_group = cm_training_df.loc[:,'gene_name']
        
        print('\nTraining data dim:', cm_X.shape
              , '\nTraining Target dim:', cm_y.shape)
        
        if all(cm_X.columns.isin(cols_to_drop) == False):
            print('\nChecked training df does NOT have Target var')
        else:
            sys.exit('\nFAIL: training data contains Target var')
        
        #---------------
        # BTS: genes
        #---------------
        cm_test_df = combined_df[combined_df['gene_name'].isin([bts_gene])]
        
        cm_bts_X = cm_test_df.drop(cols_to_drop, axis = 1, inplace = False)
        #cm_bts_y = cm_test_df.loc[:, 'dst_mode']
        cm_bts_y = cm_test_df.loc[:, target_var]
    
        print('\nTEST data dim:', cm_bts_X.shape
              , '\nTEST Target dim:', cm_bts_y.shape)
        
        
        #%%:Running Multiple models on LOGO with SKF
        cD3_v2 = MultModelsCl_logo_skf(input_df = cm_X
                        , target = cm_y
                        #, group = 'none'
                        , sel_cv = skf_cv
        
                        , blind_test_df = cm_bts_X
                        , blind_test_target = cm_bts_y
                        
                        , tts_split_type = tts_split_type
                        
                        , resampling_type = 'none' # default
                        , add_cm = True 
                        , add_yn = True 
                        , var_type = 'mixed'
                        
                        , run_blind_test = True
                        , return_formatted_output = True
                        , random_state = 42
                        , n_jobs = 10
                        )
        
        cD3_v2.to_csv(outFile)

#%%
#CMLogoSkf(combined_df)
CMLogoSkf(combined_df, std_gene_omit=['alr'])
